<?php
/*
Plugin Name: RandImage
Plugin URI: http://meandmymac.net/plugins/randimage/
Description: Allows to show random images from the WordPress media library.
Author: Arnan de Gans
Version: 0.2
Author URI: http://meandmymac.net
*/ 

/*-------------------------------------------------------------
 Name:      mamm_random_image

 Purpose:   Fetch and show random images from the WP media lib
 Receive:   $amount, $front, $spacer, $end
 Return:    -none-
-------------------------------------------------------------*/
function mamm_random_image($amount = 2, $front = '<li>', $spacer = '</li><li>', $end = '</li>') {
	global $wpdb;
		
	$SQL = "SELECT ID FROM ".$wpdb->prefix."posts 
		WHERE post_type = 'attachment' 
		AND (post_mime_type = 'image/jpeg' OR post_mime_type = 'image/gif' OR 
		post_mime_type = 'image/png' OR post_mime_type = 'image/bmp' OR 
		post_mime_type = 'image/tiff' OR post_mime_type = 'image/x-icon')
		ORDER BY rand() LIMIT ".$amount;

	$thumbs = $wpdb->get_results($SQL);

	echo $front;
	if($thumbs) {
		foreach($thumbs as $thumb) {
			$image = wp_get_attachment_image_src($thumb->ID, 'thumbnail', false);
			if ($image) {
				list($src, $width, $height) = $image;
				$hwstring = image_hwstring($width, $height);
				if (is_array($size))
					$size = implode('x', $size);
				echo '<a href="'.get_permalink($thumb->ID).'" alt=""><img src="'.attribute_escape($src).'" '.$hwstring.'class="attachment-'.attribute_escape($size).'" alt="" /></a>';
				if(count($thumbs) > 1) {
					echo $spacer;
				}
			}
		}
	} else {
		echo 'No images available!';
	}
	echo $end;
}
?>